//- Jeigu vedate int' - susumuoj int'us;//
//- Jeigu vedate float' - susumuoj float'us; ( su kableliu )//
//- Jeigu vedate double' - susumuoj double'us; ( su E, pvz.: 10E+1 )//

#include <cstdlib>
#include <iostream>
#include <string.h>

using namespace std;

// Jeigu skaiciai sveiki ->
namespace cool {
  int suma ( int a, int b ) {
    cout << a+b << endl;
  }
}
// Pirmas int, antras float
namespace intfloatcool {
  float suma ( int a, float b ) {
    cout << a+b << endl;
  }
}
// Antras float, antras int
namespace floatintcool {
  float suma ( float a, int b ) {
    cout << a+b << endl;
  }
}
// Jeigu skaiciai ne-sveiki ->
namespace notcool {
  float suma ( float a, float b ) {
    cout << a+b << endl;
  }
}
// Jeigu skaiciai standartines skaiciu israiskos
namespace supercool {
  double suma ( double a, double b ) {
    printf("%E\n", a+b);
  }
}

// Jeigu klaida ->
namespace error {
  void talk() {
    printf("Tai klaida!\n");
  }
}

/* Checks if string is int, float or string
* 0 - error ?
* 1 - integer
* 2 - float
* 3
* 4 - string
*/
int check ( string str ) {
  int idx;
  int numbersfound = 0;
  int dotsfound = 0;
  int esfound = 0;
  int STRINGLENGTH = str.length();
  for ( idx = 0; ( idx < STRINGLENGTH) && ( str[idx]); idx++ ) {
    numbersfound += (( str[idx] >= '0') && ( str[idx] <= '9'));
    dotsfound += (str[idx] == '.');
    esfound += (str[idx] == 'E');
  }
  if ( numbersfound == STRINGLENGTH )
    return 1;
  else if (( dotsfound == 1) && ( numbersfound == STRINGLENGTH-1 ))
    return 2;
  else if (( esfound == 1 ) && (dotsfound == 0) && (numbersfound == STRINGLENGTH-2))
    return 3;
  else
    return 4;
  // If nothing is found
  return 0;
}

int main(int argc, char *argv[]) {
  string a, b;
  cout << "Iveskite pirma kintamaji: ";
  cin >> a;
  cout << "Iveskite antra kinamaji: ";
  cin >> b;
  // Jeigu pirmas ir antras yra int
  if ( check(a) == 1 && check(b) == 1 ) {
    using namespace cool;
    int x = atoi(a.c_str());
    int y = atoi(b.c_str());
    cool::suma(x, y);
  // Jeigu pirmas ir antras yra float
  } else if ( check(a) == 2 && check(b) == 2 ) {
    using namespace notcool;
    float x = atof(a.c_str());
    float y = atof(b.c_str());
    notcool::suma(x, y);
  // Jeigu pirmas ir antras yra double
  } else if ( check(a) == 3 && check(b) == 3 ) {
    using namespace supercool;
    double x = atof(a.c_str());
    double y = atof(b.c_str());
    supercool::suma(x, y);
  // Jeigu pirmas yra int, antras yra float
  } else if ( check(a) == 1 && check(b) == 2 ) {
    using namespace intfloatcool;
    int x = atoi(a.c_str());
    float y = atof(b.c_str());
    intfloatcool::suma(x, y);
  // Jeigu pirmas yra float, antras yra int
  } else if ( check(a) == 2 && check(b) == 1 ) {
    using namespace floatintcool;
    float x = atof(a.c_str());
    int y = atoi(b.c_str());
    floatintcool::suma(x, y);
  } else {
    using namespace error;
    error::talk();
  }
  system("PAUSE");
  return EXIT_SUCCESS;
}
